\documentclass{report}

%\usepackage{/usr/local/common/TEXINPUTS/verimagreport}
%\usepackage{verimagreport}
%\usepackage{ifthen}


%\usepackage{exercise}


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%% HTMl stuff 
\usepackage{hyperlatex}
\usepackage[colorlinks, linkcolor=blue,pdftex]{hyperref}

\htmltitle{Lurette V2 -- A tutorial}
%\htmladdress{erwan.jahier@imag.fr}
\usepackage{frames}
   
\htmldirectory{html}

\setcounter{htmldepth}{3}
\setcounter{htmlautomenu}{3}

%\htmlpanel{1}

% \htmlpanelfield{Table of contents}{tableofcontents}
% \htmlpanelfield{Contents}{hlxcontents}

% \htmlpanelfield{Index}{hlxindex}

%\HlxPrevUrl

\W\usepackage{sequential}
\htmlrule


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\usepackage[pdftex]{graphicx}
\usepackage{wrapfig}
\usepackage{xspace}

% \NeedsTeXFormat{LaTeX2e}
% \listfiles   


% \documentclass[11pt]{article} 
% \usepackage[latin1]{inputenc} 

% \usepackage[T1]{fontenc} 



%Check if we are compiling under latex or pdflatex
% \ifx\pdftexversion\undefined
%   \usepackage[dvips]{graphicx}
% \else
%   \usepackage[pdftex]{graphicx}
%   \pdfinfo{ 
%     /Title (A Lurette Tutorial)
%     /Creator (latex)
%     /Author  (Erwan Jahier)
%   }
% \fi

\usepackage{boxedminipage}
\usepackage{amsfonts,amssymb,amsmath}
\usepackage{color}
\input{/home/jahier/TeXinputs/xcolor-ex}

\input{macros}


\usepackage{alltt}

\texorhtml{\usepackage{fullpage}}{}


\title{Lurette V2 -- A tutorial
  \texorhtml{
    \footnote{
      \href{./html/tutorial.html}
	   {This tutorial is also available in html.}}
  }{
    {\xlink{\small (pdf version)}{../tutorial.pdf}}
  }
}
\author{Erwan Jahier}

\date{Initial version:  June 30, 2004 \\
Last update: June 30, 2004}


\newcommand{\qu}[1]{\texorhtml{\vspace{0.5cm} {\bf Question}:  {{\it #1}} \vspace{0.5cm}}{{\bf Question}:  {\it #1}}}



%--------------------------------------------------------------------
%--------------------------------------------------------------------
\begin{document}


%\maketitlepage

\maketitle


%\newpage

%--------------------------------------------------------------------
%--------------------------------------------------------------------
%\newpage
\texorhtml{
  \tableofcontents
  \label{tableofcontents}
  \newpage
}{}


\texorhtml{
\section*{Introduction}
}{}


Lurette has been re-implemented from scratch. In this new version, the
main novelty resides in the way the SUT environment is described.
This is done by the means of a new dedicated language called
\emph{Lucky}, a language to program non-deterministic reactive
machines.


This is the reason why the first part of this tutorial is dedicated
to the learning of Lucky. This is done step by step through a serie
of small exercises. Then, once Lucky is mastered, using Lurette
should pretty easy. The second part of this tutorial is made of small
questions which answers are straightforward; the objective of those
questions is to let one discover the different functionalities
smoothly.



Some further information can be found in 
\texorhtml{
  \href{http://www-verimag.imag.fr/~synchron/lurette/doc/lurette-man.pdf}
       {the Lurette V2 User guide}
}{
  \xlink{the Lurette V2 User guide}
	{http://www-verimag.imag.fr/\~{}synchron/lurette/doc/lurette-man.pdf}
}
%
and in 
%
\texorhtml{
  \href{http://www-verimag.imag.fr/~synchron/lurette/doc/lucky-man.pdf}
       {the Lucky Reference Manual}
}{
  \xlink{the Lucky Reference Manual}
	{http://www-verimag.imag.fr/\~{}synchron/lurette/doc/lucky-man.pdf}
}


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\chapter{A Lucky tutorial}

A Lucky program is an interpreted automaton whose transitions define
the reactions of the machine.  Each transition is labelled by: 
\begin{itemize}
\item a set of constraints (a relation) that defines the set of the
possible outputs for one step, and
\item a weight that defines the relative probability for its
transition to be taken.
\end{itemize}


We explain the concepts and the operational semantics of Lucky all
along the examples and exercises that are provided in the sequel.
In order to do this tutorial, you need a {\tt lucky} interpreter.
You already have it if you have previously obtained the Lurette
distribution.  Otherwise, you can download it
\texorhtml{\href{http://www-verimag.imag.fr/~synchron/lurette/lucky.html}{at
{\tt www-verimag.imag.fr/\~{}synchron/lurette/lucky.html}}
}{\xlink{Here}{http://www-verimag.imag.fr/\~{}synchron/lurette/lucky.html}}.

Some basic notions on the use of Unix shells is assumed to perform this tutorial.


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\section{First steps with the Lucky interpreter}

The Lucky programs interpreter is named \lucky. If it is in your PATH,
you should be able to launch it from a shell.

\begin{example}
> {\bf lucky -help}
usage: lucky [options]* (<file.luc>)+ 
   options: 
 
  --boot, -boot, -b
    The Lucky machine starts generating values.

  --with-seed, --seed, -seed
    Set the value of the seed the random engine is initialized with (0 lets the system draw a seed).

  --step-number, -l
    Set a bound on the number of steps to perform.

  --precision, -precision, -p
    Set the precision used for numerical values (number of digits).

  [...cont'd]
%
%   --step-inside
%     Draw inside the convex hull of solutions.
%  
%   --step-edges
%     Draw inside the convex hull of solutions, but a little bit more at edges and vertices.
%  
%   --step-vertices
%     Draw among the vertices of the convex hull of solutions.
%  
%   --show-aut, -s
%     Run lucky showing the lucky automata.
%
%   --no-show-aut
%     Do not show the luc automata (Default).
%
%   --locals, -locals, -loc
%     Shows local variables.
%
%   --compute-poly-volume
%     Compute the polyhedra volume before drawing: more fair, but more expensive.
%
%   --verbose, -verbose, -v
%     Set on a verbose mode.
%
%   --pre-processor, -pp
%     Pipe lucky file(s) through a preprocessor (e.g., cpp).
%
%   --help, -help, -h
%     Display this message.
\end{example}

We explain the use of most of those options in the sequel.

If you are not the owner of the directory where Lurette is installed
(i.e., if the installation has been made globally) you need to copy
the {\tt lurette/demo-lucky} directory into your own local
space, and move to there.

\begin{example}
  > {\bf cp -r /jahier/lurette-i386-linux-V2-1.29/demo-lucky . }
  > {\bf cd /jahier/lurette-i386-linux-V2-1.29/demo-lucky}
\end{example}

There, you can find several lucky ({\tt .luc}) files. You can start
to launch a simple one which is named {\tt
simple.luc}\footnote{Everything that is at the right-hand-side of the
shell prompt character {\tt >} is the user input. All the other lines
are the Lucky outputs. Here and in the sequel, the convention is that
anything that has been typed in by the user (i.e., you) is displayed
in {\tt \bf bold}}:

\begin{example}
  > {\bf lucky simple.luc}
  # This is Lucky Version V2-1.29
  # The random engine was initialized with the seed -433890083
  # inputs "Max":int 
  # outputs "J":int 
\end{example}



As one can guess according to the output message, this Lucky
program has one integer input {\tt Max}, and one integer output {\tt
J}. If we enter one integer, say {\tt 6}, Lucky returns back
two lines: one containing the cycle (or step) number, and one
containing the value of the unique output of that program.

\begin{example}
  {\bf 6}
  #step 1
  #outs 4 

  {\bf 6}
  #step 1
  #outs 2
\end{example}

Then, you can enter several other integers and observe the Lucky
outputs. In particular, you may notice that with the same input,
Lucky does not always produce the same output.

To exit the Lucky infinite loop, enter {\tt q}.


Let us have a look at the {\tt simple.luc} Lucky program\texorhtml{
of Figure~\ref{simple-luc}}{}.

 \begin{figure}[tbh]
   \texorhtml{
     \begin{center}
       \begin{minipage}[c]{0.75\textwidth}
	 \begin{small}
	   \begin{example}
	     \input{simple}
	   \end{example}
	 \end{small}
       \end{minipage}
     \end{center}
   } {
     \htmlrule
     \begin{example}
       \input{simple}
     \end{example}
     \htmlrule
   } 
   \caption{The {\tt simple.luc} Lucky file.}
   \label{simple-luc}
 \end{figure}


Any characters at the right-hand-side of \commentaire{{\tt -{-}} is
ignored (comments)}.  Lucky keywords are displayed \kwd{like that}.
The first two lines of Figure~\ref{simple-luc} define the machine
interface. Then follows the automaton node declarations: here, the
automaton contains only one node which is labelled by {\tt 0}.  We
will explain the keyword \kwd{stable} later.

In the end come the transitions definitions.  The automaton {\tt
simple.luc} contains only one transition which is labelled by the
formula ``{\tt 0 <= J \kwdd{and} J <= Max}'', which states that the output
should always be positive, and smaller or equal than the input.


\qu{what happens if the input is negative? why?}

% if the input is negative, this constraint have no solution. Since it
% is the only transition, in such a case the Lucky interpreter stops.



Some Lucky programs don't even have an input. Try to execute {\tt
simpler.luc} using the {\tt -{-}step-number} option several times.

\begin{example}
  > {\bf lucky --step-number 10 simpler.luc}
\end{example}

You may have noticed that the sequences that are generated are not
always the same, because the seed that is used to initialize the
random engine has been chosen randomly. One can enforce Lucky to use
a seed thanks to the {\tt -{-}with-seed} option.



%\newcommand{\exercice}[1]{\texorhtml{\vspace{1cm}{{\bf #1}} \vspace{1cm}}{{\bf #1}}}

\begin{exercise}
Try to obtain a sequence that you have previously generated with the
{\tt simpler.luc} program.
\end{exercise}


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\section{Using memories}

As in Lustre, memories can be managed in Lucky via the \kwd{pre} operator
(e.g., {\tt Dudt = u - \kwd{pre} u}).


\begin{exercise}
Modify the {\tt simple.luc} file in such a way that two consecutive
outputs and never the same.
\end{exercise}

% XXX 
% \section{Local variables}
% \begin{exercise}
% \end{exercise}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\section{More complex constraints}

Of course, one can write more complex constraints using logical ({\tt
and}, {\tt or}, {\tt nor}, {\tt xor}, {\tt =}, {\tt =>}, {\tt <>} ,
{\tt <}, {\tt >}, {\tt <=}, {\tt >=}) and numeric ({\tt +}, {\tt -},
{\tt *}, {\tt /}, {\tt div}, {\tt mod}, {\tt abs}) operators. Boolean
and numeric expressions can be combined via if-then-else and
comparison operators ({\tt <}, {\tt =}, {\tt >}, etc.).


\begin{exercise}
Edit the {\tt fairness.luc} file. What should be the distribution of the outputs? \\
You can check it using that kind of commands:

\begin{example}
  > {lucky -l 10000 fairness.luc | grep outs | grep - | wc}
  > {lucky -l 10000 fairness.luc | grep outs | grep  9999 | wc} 
\end{example}

\noindent
Can you explain the results? 


\noindent
Try again using the {\tt --compute-poly-volume} options (which ought
to be called {\tt --fair-draw}... it will be in V2-1.33!).
\end{exercise}



%%% 

% recase losange-10d ici .



%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\section{Using the control structure to control distribution}


\begin{exercise}
\label{lustre-automaton}
Consider the {\tt lustre\_automaton.luc} file. What does this
automaton do?  How can one modify this program in such a way that
going to state 1 is twice as many probable that going to the 2 other
states? 
\end{exercise}

If you managed to do the previous exercise, you are probably
convinced that this trick is not satisfactory.  It is precisely
because Lustre-like languages make it difficult to assign
probabilities to different possible behaviors that Lucky was
designed. 
%
That kind of automaton can therefore be coded in Lucky using the
explicit control structure it provides, namely, the automaton nodes.
Then, one can assign a weight (using \kwddd{~weight} directive) to
the different transitions. For example, if we have 2 transitions

\begin{example}
\kwd{nodes} \{ toto : stable; tata : stable ; titi : stable \}
\kwd{transitions} \{ 
  toto -> tata \kwddd{\~{}weight} 1 \kwddd{\~{}cond} c1;
  toto -> titi \kwddd{\~{}weight} 3 \kwddd{\~{}cond} c2;
\}
\end{example}


then the first transitions will be taken in 25\% of the time (if c1
is satisfiable). Note that if no weight is specified, a weight of 1
is assumed.




In the previous examples, there were only one node and one
transition; we are now going to write non-degenerated automaton with
several nodes and several transitions.


\begin{exercise}
  Rewrite the {\tt lustre\_automaton.luc} file using Lucky nodes.
  Add \kwddd{~weight} directive to solve the previous exercise.
\end{exercise}


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\section{Dynamic weights}

The concept of \emph{dynamic weights}; weight labels can also be
numerical functions of the inputs and the past-values.
%
This can be particularly useful to model an {\em alive process} where
the system has a known average life expectancy before breaking down;
at each reaction, the probability to work properly depends {\em
numerically} on an internal counter of the process age.



\begin{exercise}
Run the Lucky automaton {\tt dynamic\_weight.luc}. What is the life
expectancy of the sensor {\tt X} if we assume that {\tt X} is broken
when it is set to $-1$? Modify the weight label in this automaton
in such a way that its life expectancy is 100 cycles.
\end{exercise}



%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\section{Transient and stable nodes}

The concept of \emph{transient} and \emph{stable nodes}, is simply a
 facility that help to structure Lucky programs better.  A complete
 reaction is a sequence of transitions between two stable nodes,
 where all the intermediate nodes are transient. The constraints that
 are used to perform one reaction is the conjunction of the
 constraints labelling the transitions between the two stable nodes.

For example, in the following

\begin{example}
\kwd{nodes} \{ s1, s2 : stable; t : transient \}
\kwd{transitions} \{ 
  s1 -> t \kwddd{~cond} c1;
  t -> s2 \kwddd{~cond} c2;
\}
\end{example}


if the current node is s1, then the next node will be s2, and the constraint 
that will be used to compute the step will be {\tt c1 and c2}.

\begin{exercise}
  Rewrite the automaton of Exercice~\ref{lustre-automaton} using transient nodes in
  such a way that no formula is duplicated (to perform the first
  step).
\end{exercise}


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\section{Infinite weights and mandatory choice}

Mandatory choice can be defined via the use of {\tt infinity} weight.
It is forbidden to have two transitions from the same node with
infinite weights.

\begin{exercise}
Rewrite the automaton {\tt mandatory.luc} in such a way that state2
and state3 have the same probability when both are possible, and are
mandatory with respect state1 when possible.
\end{exercise}

\qu{When two transitions with infinite weights have the same origin,
an alternative (to this restriction) would have been to perform a
fair toss among them. How can one achieve the same effect?  What is
the advantage of doing that way?}



%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\section{Structured types}

An (obfuscated) example of the use of structured type is provided in
the file {\tt structured\_type.luc}.

\begin{exercise}
  Try to generate 1000 random values between 0 and 100 with a 6 lines
36 characters Lucky program.
\end{exercise}


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\section{Using  pre-processors}



Before the Lucky file is parsed, one can apply a pre-processor to it
using the {\tt --pre-processor} (or {\tt --pp} for short) command
line option. This can be useful to define macros for instance.  The
{\tt <arch>/bin/} directory of the Lurette distribution contains a
small script called {\tt lucky\_cpp} that wrap a call to cpp (the C
pre-processor) with sed commands that transform C-style comments into
Lucky-style ones, and vice-versa. 

\begin{exercise}
  Define using cpp a macro called up\_and\_down(V, Min, Max, Delta)
  that constraint Var in such a way that it goes up and down (and so
  on) between Min and Max, with a derivative bounded by Delta. \\ 
  Use it in a Lucky program that have no input and one (numeric) output.
\end{exercise}



% \section{Lucky automata product}

% This can be useful to merge  several Programs. The restrictions
% are that ...

% \begin{example}
%   > lucky simple.luc simpler.luc
% \end{example}



%\section{The Lucky interpreter command line options}
% -boot
 
% \subsection{}




% Encode the automaton of Figure~\label{fig:lucky_example}.

% \section{Solutions of the exercises}












%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\chapter{A Lurette tutorial}

In order to do this tutorial, you need the Lurette package installed
at your site. You can obtain it (freely!)
\texorhtml{
  \href{http://www-verimag.imag.fr/~synchron/lurette/lurette.html}
       {at {\tt www-verimag.imag.fr/\~{}synchron/lurette/lurette.html}}
}{
  \xlink{there}
	{http://www-verimag.imag.fr/\~{}synchron/lurette/lurette.html}
}


The first part of this tutorial contains no question and can be read
without launching Lurette.  However, we advice that you perform the
Lurette session while reading the tutorial. In order to do so, if
your are not the owner of the directory where Lurette is installed
(i.e., if the installation has been made globally) you need to copy
the {\tt
lurette-<arch>-<version>/demo-xlurette/fault-tolerant} directory
into your own local space, move to there, and launch \xlurette.


\begin{example}
  \color{DarkSlateGrey}
  > mv /home/jahier/lurette-i386-linux-V2-1.29/demo-xlurette/fault-tolerant .
  > cd fault-tolerant
  > xlurette
\end{example}



The second part is more interactive. It is made of a serie of
straightforward exercises which aim at present you the various
functionalities and options of the tool smoothly.


% All the responses should be somewhere in 
% %
% %the Lurette user guide~\cite{lurette-user}.
% %
% \texorhtml{
%   \href{http://www-verimag.imag.fr/~synchron/lurette/lurette-man.pdf}
%        {the Lurette V2 User guide}
% }{
%   \xlink{the Lurette V2 User guide}
% 	{http://www-verimag.imag.fr/\~{}synchron/lurette/lurette-man.pdf}
% }.




%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\input{fault-tolerant-tut}



%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\section{Exercises}

In order to do those exercices, we suppose you have run the examples
of the previous section. 

Hint: pay attention to tool-tips that are displayed if you leave the
mouse pointer long enough on the different buttons of the \xlurette\ GUI.
Otherwise, dig into  
%
\texorhtml{
  \href{http://www-verimag.imag.fr/~synchron/lurette/lurette-man.pdf}
       {the Lurette V2 User guide}
}{
  \xlink{the Lurette V2 User guide}
	{http://www-verimag.imag.fr/\~{}synchron/lurette/lurette-man.pdf}
}.


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\subsection{Saving a test session}


Try to save your session. Then quit and re-launch \xlurette.



%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\subsection{Running a program step by step}


Try to run the program step by step.


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\subsection{Create a batch file}


Try to create a batch file and run it outside  \xlurette.



%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\subsection{Managing RIF files}


%\begin{exercise}

Try to inspect the Data file ({\tt .rif}) that have been generated.

% \end{exercise}


Try to change the name of the RIF file that is generated. 

Try to generate post-script files from the generated data.  




%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\subsection{Changing various test parameters}


During a run of the {\tt heater\_control.lus} program with the
environment {\tt sensors.luc},  try to obtain a test thickness of 1,
13, 17, 200000.

Compare the execution time of a run of length 10 with a thickness of
10000, and a run of length 100000 with a thickness of 1.  Can you
explain why there is a difference?

Try the same thing with {\tt degradable-sensors.luc} (remove the oracle
to make those experiences easier).



Imagine you have a RIF file that is 100 steps long. How could you
generate a 200 steps long one, where the first 100 steps are exactly
the same?  What is missing in the {\tt .rif} file to make sure we
really have exactly the same first 100 steps?
%%%% il faut que les parametres d'epaissuers soient les memes !!!
%%% les mettre dans le .rif ??



%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\subsection{Linking external C files}


Modify the {\tt heater\_control.lus} program in such a way that the
{\tt MIN} and the {\tt MAX} constants are set via a C file.  To do
that, 

replace
\begin{example}
  const DELTA = 0.5;
\end{example}

by

\begin{example}
  const DELTA : real;
\end{example}

and create a C file named {\tt heater\_control\_ext.h} that contains
{\tt \#define DELTA (0.5)"} and an C header file named {\tt
heater\_control\_ext.c} that contains {\tt \#include
"heater\_control\_ext.h"}.

Now, try to run that new Lustre file.


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\subsection{Testing programs that are not written in Lustre}

Try to perform a run using directly the C file.

Try to use the Scade compiler mode to perform the test.

What happens if you select as the SUT a C program generated by the
Verimag lustre compiler when the Scade or the Sildex are selected?



%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\subsection{Running several automata in parallel}

Split the Lucky automaton {\tt sensor.luc} into two files and execute them
in parallel.



%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%% %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% \texorhtml{\newpage \appendix}{}
% \input{lucky-syntax}

 

\end{document}
